org 0h

        push cs
        pop ds

        mov ax, 35FEh           ; Get Some Info
        int 21h
        mov [dataseg], es
        mov [dataoff], bx
        mov si, bx

    ; ---- INIT
        
mainexecloop:
        mov ax, 9               ; Function 9h - kbhit?
        mov es:[si], ax
        int 0FFh
        mov ax, es:[si+2]
        cmp ax, 0
        jnz kbhit               ; Yes -> Jmp kbhit

        mov ax, 3               ; Function 3h - Get last signal
        mov es:[si], ax
        mov ax, 0FFh            ; Get own signal
        mov es:[si+2], ax
        int 0FFh                ; DO that!
        mov ax, es:[si+4]
        cmp ax, 1               ; Signal 1 (Paint)?
        jz dopaintme
        cmp ax, 2               ; Signal 2 (Term)?
        jz quitme

    ; ---- SIGNAL PROCESSING

dotswitch:                      
        int 0FCh
        push cs
        pop ds
        mov es, [dataseg]
        mov si, [dataoff]
        jmp mainexecloop

dopaintme: jmp paintme
quitme:

    ; ---- TERMINATION

        xor ax,ax               ; Function 0 - Kill
        mov es:[si], ax
        mov ax, cs              ; Store CS
        mov es:[si+2], ax
        int 0FFh                ; DO that (bye,bye)
            ; Still there? Let's do a taskswitch
        int 0FCh
            ; Really killed. If not: hang in a quit-loop
        jmp quitme

kbhit:
        mov ax, 0ah             ; Function a - getch
        mov es:[si], ax
        int 0FFh
        mov ax, es:[si+2]       ; Get it in AL

    ; ---- Q=Quit, but you can modify this here
        xor di, di
        mov ah, al
        or al, 32               ; Make lowercase
        cmp al, 'q'             ; q(uit)
        jz quitme
        cmp ah, '1'             ; Jump if the user wants a different amount
        jz adices
        cmp ah, '2'
        jz bdices
        cmp ah, '3'
        jz cdices
        cmp ah, '4'
        jz ddices
        cmp ah, '5'
        jz edices
        cmp ah, '6'
        jz fdices
        cmp ah, 13
        jz dodice
        cmp ah, 10
        jz dodice
        cmp ah, 32
        jz dodice

    ; ---- KEY PROCESSING

        jmp dotswitch           ; Let's make a taskswitch

fdices: inc di                  ; Dynamic....
edices: inc di
ddices: inc di
cdices: inc di
bdices: inc di
adices: inc di                  ; recog.
        mov ax, di
        mov ah, [numdice]

        mov [numdice], al       ; Save the value
        cmp ah, al              ; Prev.Num. larger?
        jnbe paintme            ; Yes -> Whole rpaint
                                ; No -> Throw dices

dodice:     ; Throw dices. Currently only a jump to the painter
        jmp drawonlydice

paintme:
    ; ---- PAINTING

        mov ax, 82h             ; Function 82h - Display
        mov es:[si], ax
        mov ax, 5h              ; SubFunction 5h - paint rectangle
        mov es:[si+2], ax
        mov ax, 0FFFFh          ; FFFFh - Paint entire rectangle
        mov es:[si+4], ax
        mov ax, 1               ; Color 1 
        mov es:[si+12], ax
        int 0FFh                ; DO that!

    mov ax, 6                   ; SubFunction 6 - Textout
    mov es:[si+2], ax
    mov ax, 5                   ; X
    mov es:[si+4], ax
    mov ax, 90                  ; Y
    mov es:[si+6], ax              
    mov ax, 12                  ; FG.Color 14
    mov es:[si+8], ax
    mov ax, -1                  ; BG.Color none
    mov es:[si+10], ax
    mov ax, 1                   ; Font 0 (8x16)
    mov es:[si+12], ax
    mov es:[si+14], cs          ; Segment
    mov ax, dicetext            ; Offset
    mov es:[si+16], ax          
    int 0FFh                    ; phew!


    ; Draw dice(s)
drawonlydice:
        mov al, [numdice]
        mov cx, 10              ; Set X/Y
        mov dx, 10
ddiceloop:
        push ax
        call drawdice           ; Draw a random dice
        pop ax
        dec al                  ; Decrement
        jnz ddiceloop           ; If not 0 draw next dice

        jmp dotswitch           ; Let's make a taskswitch

    ; ---- SUBS

; Draws a random dice at CX=X,DX=Y
drawdice:
    mov ax, 11h                 ; Function 11 - Randomize
    mov es:[si], ax
    mov ax, 6                   ; Randomize 0-5
    mov es:[si+2], ax
    int 0FFh                    ; Do it!
    mov bx, es:[si+4]           ; Get num.
    cmp bx, 5                   ; 0-5?
    jnbe drawdice               ; No -> Again

    shl bx, 1                   ; *2
    add bx, dicetab             ; Add the dicetable

    mov ax, 82h                 ; Function 82h - Draw something
    mov es:[si], ax
    mov ax, 6                   ; SubFunction 6 - Textout
    mov es:[si+2], ax
    mov es:[si+4], cx           ; X
    mov es:[si+6], dx           ; Y
    mov ax, 14                  ; FG.Color 14
    mov es:[si+8], ax
    mov ax, 0                   ; BG.Color 0
    mov es:[si+10], ax
    mov ax, 0                   ; Font 0 (8x8)
    mov es:[si+12], ax
    mov es:[si+14], cs          ; Segment
    mov ax, [bx]                ; Get the dice
    mov es:[si+16], ax          ; Offset
    int 0FFh                    ; phew!


    mov ax, 4                   ; SubFunction 4 - Rect
    mov es:[si+2], ax
    mov es:[si+4], cx           ; X
    mov es:[si+6], dx           ; Y
    add cx, 72                  ; Adjust X
    add dx, 72                  ; Adjust Y
    mov es:[si+8], cx           ; X2
    mov es:[si+10], dx          ; Y2
    mov ax, 7                   ; Color 7
    mov es:[si+12], ax
    int 0FFh                    ; DO it!
    add cx, 10                  ; Next dice-pos
    sub dx, 72

        ; We're finished. CX:DX points to next dice-xy

    ret

dataseg dw 0
dataoff dw 0

    ; ---- VARIABLES

numdice db 1

    ; ---- DATA
dicetext:
            db 'DICEr - This is a simple dice-thrower.',10
            db 10
            db 'Press 1..6  to define how many dices you want to throw',10
            db 'Press Space to throw the dice(s)',10
            db 'Press Q     to quit this proggie',10
            db 10
            db 'This program was written by Simon Laburda (simbone@gmx.at)',0
dicetab:
        dw OFFSET dicea, OFFSET diceb, OFFSET dicec
        dw OFFSET diced, OFFSET dicee, OFFSET dicef

dicea:  db '',10
        db '       ',10
        db '       ',10
        db '       ',10
        db '   O   ',10
        db '       ',10
        db '       ',10
        db '       ',10
        db '',0

diceb:  db '',10
        db '       ',10
        db ' O     ',10
        db '       ',10
        db '       ',10
        db '       ',10
        db '     O ',10
        db '       ',10
        db '',0

dicec:  db '',10
        db '       ',10
        db ' O     ',10
        db '       ',10
        db '   O   ',10
        db '       ',10
        db '     O ',10
        db '       ',10
        db '',0

diced:  db '',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db '       ',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db '',0

dicee:  db '',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db '   O   ',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db '',0

dicef:  db '',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db ' O   O ',10
        db '       ',10
        db '',0


