; fast640 - driver for 640x480x4 direct vram-access

    jmp startme

fillrect:
        cmp cx, 0
        jnz notderstood
        cmp dx, cx
        jnz notderstood
        cmp si, 639
        jnz notderstood
        inc di
        jmp dothefill

dstrt:
    cmp ah, cs:[mydrvid]
    jnz retjmp

    cmp al, 0
    jz retdata
    cmp al, 1
    jz retmode
    cmp al, 2
    jz setmode
    cmp al, 3
    jz setpixel
    cmp al, 4
    jz getpixel
    cmp al, 5
    jz hline
    cmp al, 6
    jz vline
    cmp al, 8
    jz fillrect
    cmp al, 0FFh
    jz freemem
notderstood:
    mov ax, 0FFFFh
    mov bx, 0FFFFh
    mov cx, 0FFFFh
    mov dx, 0FFFFh
    iret

retjmp: jmp 0FFFFh:0000h

retmode:
        mov ax, 640
        mov bx, 480
        mov cx, 4
        iret

retdata:
        xor ah, ah
        mov al, 1
        iret

freemem:
    mov ax, 3
    int 10h

    mov ax, cs
    xor bx, bx
    xor cx, cx
    xor dx, dx
    mov si, 1234h
    iret

setmode:
        mov ax, 12h
        int 10h
        iret

vline:  jmp dovline

setpixel:
        mov ah, cs:[lastcol]    ; Get last color
        cmp bl, ah              ; The same?
        jz pixcolok             ; Yes -> Just set it

        call setcheckcol
pixcolok:
    ; BY WILL BARATH----

        mov di, dx              ; Y to DI
        Mov ax, 0a000h
        Mov es, ax
        Mov bx,cx               ; X to BX
        Mov ax,80
        Mul di                  ; *Y
        SHR bx,3
        Add bx,ax
        And cl,07h
        Mov al,80h
        Shr al,cl
        Mov dx,3cfh
        Out dx,al
        Mov ah,0ffh
        Or es:[bx],ah
        iret

getpixel:
        iret

hline:
        push bp
        inc di
        push di                 ; Save X2
        call checkcol

        Mov ax, 0a000h
        Mov es, ax

        mov di, dx              ; Y to DI
        Mov ax,80
        Mul di                  ; *Y

        pop di
        mov bp, ax

hlineloop:
        mov ax, bp
        mov bx, si
        mov cx, si
        SHR bx,3
        Add bx,ax
        And cl,07h
        Mov al,80h
        Shr al,cl
        Mov dx,3cfh
        Out dx,al
        Mov ah,0ffh
        Or es:[bx],ah

        inc si
        cmp si, di
        jnz hlineloop
        pop bp
        iret

checkcol:   ; Modifies: AX, BL
        mov ah, cs:[lastcol]    ; Get last color
        cmp bl, ah              ; The same?
        jz colok                ; Yes -> Just set it
setcheckcol:
        push dx
        Mov dx,3ceh
        Xor al,al
        Mov ah,bl               ; Color
        mov cs:[lastcol], bl    ; And set this
        And ah,0fh
        Out dx,ax
        Mov ax,0f01h
        Out dx,ax
        Mov al,08h
        Out dx,al
        pop dx
colok:
        ret

dovline:
        inc di
        push di                 ; Save Y2
        call checkcol

        Mov ax, 0a000h
        Mov es, ax

        mov di, si              ; Y1 to DI
        Mov ax,80
        Mul di                  ; *Y

        pop di                  ; Get Y2

vlineloop:
        push ax
        push cx
        mov bx, cx
        SHR bx,3
        Add bx,ax
        And cl,07h
        Mov al,80h
        Shr al,cl
        Mov dx,3cfh
        Out dx,al
        Mov ah,0ffh
        Or es:[bx],ah
        pop cx
        pop ax

        add ax, 80
        inc si
        cmp si, di
        jnz vlineloop
        iret

dothefill:      ; DI=Y-Max, BX=Color
        push bp
        sti
        call checkcol

        Mov ax, 0a000h
        Mov es, ax
        xor si, si
        xor bp,bp
        xor cx,cx
        Mov dx,3cfh

fillloop:
        push cx
        mov bx, cx
        SHR bx,3
        add bx, bp
        And cl,07h
        Mov al,80h
        Shr al,cl
        Out dx, al
        Mov ah,0ffh
        Or es:[bx],ah
        pop cx

        inc cx
        cmp cx, 640
        jnz fillloop

        add bp, 80
        xor cx, cx
        inc si

        cmp si, di
        jnz fillloop

        pop bp
        iret

mydrvid db 0
lastcol db 255

nop
startme:
        mov ax, [02ch]          ; Get enviroment
        mov es, ax
        mov ah, 49h             ; Free...
        int 21h                 ; ...memory

    mov ax, 35FDh
    int 21h
    mov ax, es
    mov [retjmp+1], bx
    mov [retjmp+3], ax

    mov ax, 25FDh
    mov dx, dstrt
    int 21h

    mov ax, 35FEh
    int 21h
    mov ax, es:[bx]
    mov [mydrvid], al

    mov dx, startme
    int 27h
