
; Ulsop-Multitasker
; Copyright (C) 2002 by Simon Laburda (simbone@gmx.at)

        jmp dostartme

    ; This is called when a program wants to give control to other tasks
multiint:
        mov cx, sp                  ; Get the stack
        mov ax, ss
        mov dx, ax

        mov ax, cs                  ; Init. the datasegs
        mov ds, ax
        mov ax, [dataseg]
        mov es, ax

        mov bx, [shutdown]          ; Sys. Shutdown?
        mov ah, es:[bx]
        cmp ah, 0                   ; <> 0?
        jnz getout                  ; -> End me

        mov ax, 6                   ; Fkt. 6 get new stack
        mov bx, [dataoff]
        mov es:[bx], ax
        mov es:[bx+2], dx
        mov es:[bx+4], cx

        int 0FFh                    ; Do it
        mov ax, es:[bx]             ; At this point the kernel could panic,
        cmp ax, 0FFFFh              ; so check this.
        jz getout                   ; Yes -> Terminate me

        cli                         ; Disable interrupts during stack-manipulation
        mov ax, es:[bx+2]
        mov ss, ax
        mov ax, es:[bx+4]
        mov sp, ax
        sti                         ; Stack restored

        pop si                      ; IP
        pop es                      ; CS
        pop cx                      ; FLAGS (ignore)
        pushf                       ; We don't want the proggies flags
        push es
        push si

        iret

getout: int 20h

dataseg     dw 0        ; Datastruct-Segment
dataoff     dw 0        ; Datastruct-Offset
runtask     dw 0        ; Ptr. to running task
shutdown    dw 0        ; Ptr. shutdown-flag

; This is aligned at bottom, so we will get more stack-space
dostartme:
        ; Free some RAM

        cli
        mov ax, 510             ; Stack-reseek
        mov sp, ax

        mov ax, cs              ; Get Code-Seg.
        mov es, ax
        mov ah, 49h
        mov bx, 20h             ; We want only 20h Paragraphs (=512 Byte)
        int 21h
        
        ; Let's get some infos

        mov ax, 35FEh
        int 21h
        mov [dataoff], bx
        mov [dataseg], es

        mov ax, 4               ; Fkt. 4 - Get system areas
        mov es:[bx], ax
        int 0FFh

        mov bx, [dataoff]
        mov ax, es:[bx+6]
        mov [runtask], ax

        mov bx, ax              ; There is no task running
        mov ah, 0FFh
        mov es:[bx], ah

        mov bx, [dataoff]
        mov ax, es:[bx+12]
        mov [shutdown], ax

        ; Then get the multitasker-int

        mov dx, multiint
        mov ax, 25FCh
        int 21h

        ; GO! Let the system run and give control to the first task....

        jmp multiint
