
//  AH=Driver-ID AL=Fkt.ID
//  Disp.Driver:
//   Function 0 - ?:
//    Out: AH=00h (Ident.Disp.Driver)
//    Out: AL=Number of sup.modes
//   Function 1 - Get Modedata:
//    In : CL=Mode-ID
//    Out: AX=X-Res
//    Out: BX=Y-Res
//    Out: CX=Colorbits
//   Function 2 - Set mode:
     char setres(char nosilent);
     char setresext(char nosilent, int x, int y, int c);
//    In : BX=Internal Mode-ID
//   Function 3 - Setpixel:
     void setpixel(UINT x, UINT y, UINT col);
//    In : CX=X (Column)
//    In : DX=Y (Row)
//    In : BX=Color (24/32-Bit Modes: SI:DI, BX=FFFE)
//   Function 4 - Getpixel:
     UINT getpixel(UINT x, UINT y);
//    In : CX=X (Column)
//    In : DX=Y (Row)
//    Out: BX=Color (24/32-Bit Modes: SI:DI, BX=FFFE)
//   Function 5 - Draw HLINE:
     void hline(UINT y, UINT x1, UINT x2, UINT col);
//    In: DX=Y
//    In: BX=Color
//    In: SI=X1
//    In: DI=X2
//   Function 6 - Draw VLINE:
     void vline(UINT x, UINT y1, UINT y2, UINT col);
//    In: CX=X
//    In: BX=Color
//    In: SI=Y1
//    In: DI=Y2
//   Function 7 - Draw RECT:
     void drawrect(UINT x1, UINT y1, UINT x2, UINT y2, UINT col);
//    IN: CX=X1
//    In: DX=Y1
//    In: BX=Color
//    In: SI=X2
//    In: DI=Y2
//   Function 8 - Draw FILLRECT:
     void drawrectf(UINT x1, UINT y1, UINT x2, UINT y2, UINT col);
//    IN: CX=X1
//    In: DX=Y1
//    In: BX=Color
//    In: SI=X2
//    In: DI=Y2

#ifndef UCHR
 #define UCHR unsigned char
 #define UINT unsigned int
 #define ULNG unsigned long
#endif

struct displaydata
    {
    UCHR drivnum;   // Supported through driver
    UCHR modeid;    // Driver-Modeid
    UINT xres;      // X-Resolution
    UINT yres;      // Y-Resolution
    UINT cdeep;     // Colors (in Bits)
    };  // Size: 8 Byte

struct displaydata dismodes[64];
UCHR *fonttab[16];
UCHR dispmodeid;
UINT curdispx=0, curdispy=0, curdispc=0;
UINT globvid,vidi,vidj,vidk;
UCHR ci;

char setres(char nosilent)
    {
    return setresext(nosilent,atoi(getentry("XRES")),atoi(getentry("YRES")),atoi(getentry("CDEEP")));
    }

char setresext(char nosilent, int x, int y, int c)
    {
    UINT i;
    UCHR aaa,bbb;

    if(x == 0 || y == 0) { x = 320; y = 200; c = 1; }
    if(nosilent) printf("Setting resolution: %u x %u @ %ubpp\n",x,y,c);
    for(i=0;i!=255;i++)
        if((dismodes[i].xres == x) && (dismodes[i].yres == y) && (dismodes[i].cdeep == c))
            {
            dispmodeid = i;
            aaa = dismodes[i].drivnum;
            bbb = dismodes[i].modeid;
            if(nosilent) printf("Driver: %u, Mode: %u\n",(UINT) aaa, (UINT) bbb);
            _asm
                {
                mov ah, aaa
                mov al, 2
                mov bl, bbb
                mov bh, 0
                int 0FDh
                }
            curdispx = x;
            curdispy = y;
            curdispc = c;
            ci = aaa;
            return 0;
            }
    if(nosilent)
        {
        puts("ERROR - Resolution not supported by any driver - Any key");
        getch();
        }
    return 1;
    }


void setpixel(UINT x, UINT y, UINT col)
    {
    if(mousepointeron) showhidecursor(0);
        _asm
            {
            sti
            mov cx, x
            mov dx, y
            mov bx, col
            mov ah, ci
            mov al, 3
            int 0FDh
            }
    if(mousepointeron) showhidecursor(1);
    }

UINT getpixel(UINT x, UINT y)
    {
    _asm
        {
        mov cx, x
        mov dx, y
        mov ah, ci
        mov al, 4
        int 0FDh
        mov globvid, bx
        }
    return globvid;
    }

UCHR far *ta;

void hline(UINT y, UINT x1, UINT x2, UINT col)
    {
    if(x1 == x2) goto nohline;

    if(mousepointeron) showhidecursor(0);
    _asm
        {
        mov dx, y
        mov si, x1
        mov di, x2
        mov bx, col
        mov ah, ci
        mov al, 5
        int 0FDh
        cmp ax, 0FFFFh
        jnz hlineallok
        cmp bx, 0FFFFh
        jnz hlineallok
        cmp cx, 0FFFFh
        jnz hlineallok
        cmp dx, 0FFFFh
        jnz hlineallok
        }
    nohline:;

    for(vidi=x1;vidi<=x2;vidi++)
        _asm
            {
            sti
            mov cx, vidi
            mov dx, y
            mov bx, col
            mov ah, ci
            mov al, 3
            int 0FDh
            }

    hlineallok:;
    if(mousepointeron) showhidecursor(1);
    }

void vline(UINT x, UINT y1, UINT y2, UINT col)
    {
    if(mousepointeron) showhidecursor(0);
    _asm
        {
        mov cx, x
        mov si, y1
        mov di, y2
        mov bx, col
        mov ah, ci
        mov al, 6
        int 0FDh
        cmp ax, 0FFFFh
        jnz vlineallok
        cmp bx, 0FFFFh
        jnz vlineallok
        cmp cx, 0FFFFh
        jnz vlineallok
        cmp dx, 0FFFFh
        jnz vlineallok
        }
    novline:;
    for(vidj=y1;vidj<=y2;vidj++)
        _asm
            {
            sti
            mov cx, x
            mov dx, vidj
            mov bx, col
            mov ah, ci
            mov al, 3
            int 0FDh
            }
    vlineallok:;
    if(mousepointeron) showhidecursor(1);
    }

void drawrect(UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    if(mousepointeron) showhidecursor(0);
    _asm
        {
        mov cx, x1
        mov dx, y1
        mov si, x2
        mov di, y2
        mov bx, col
        mov ah, ci
        mov al, 7
        int 0FDh
        cmp ax, 0FFFFh
        jnz rectallok
        cmp bx, 0FFFFh
        jnz rectallok       
        cmp cx, 0FFFFh
        jnz rectallok
        cmp dx, 0FFFFh
        jnz rectallok
        }
    nodrawrect:;
    vline(x1, y1, y2, col);
    vline(x2, y1, y2, col);
    hline(y1, x1, x2, col);
    hline(y2, x1, x2, col);
    rectallok:;
    if(mousepointeron) showhidecursor(1);
    }

void drawrectf(UINT x1, UINT y1, UINT x2, UINT y2, UINT col)
    {
    if(mousepointeron) showhidecursor(0);
    _asm
        {
        mov cx, x1
        mov dx, y1
        mov si, x2
        mov di, y2
        mov bx, col
        mov ah, ci
        mov al, 8
        int 0FDh
        cmp ax, 0FFFFh
        jnz rectfallok
        cmp bx, 0FFFFh
        jnz rectfallok
        cmp cx, 0FFFFh
        jnz rectfallok
        cmp dx, 0FFFFh
        jnz rectfallok
        }
    nodrawrectf:;
    globvid = mousepointeron; mousepointeron = 0;

    if((x2-x1) > (y2-y1))
        for(vidk=y1;vidk<=y2;vidk++)
            hline(vidk,x1,x2,col);
    else
        for(vidk=x1;vidk<=x2;vidk++)
            vline(vidk,y1,y2,col);
    mousepointeron = globvid;
    rectfallok:;
    if(mousepointeron) showhidecursor(1);
    }

UINT textwidth(int fntid, char *thetext)
    {
    if(fonttab[fntid][0] == 0)  // Font Version 0
        return 8 * strlen(thetext);

    return 0;
    }

UINT textheight(int fntid, char *thetext)
    {
    if(fonttab[fntid][0] == 0)  // Font Version 0
        return fonttab[fntid][1];

    return 0;
    }

    // 0=OK, 1=Error
char outtext(int x, int y, int fgc, int bgc, int fntid, char far *thetext)
    {
    UINT pxhigh;
    UCHR *suchptr;
    UCHR *text=(UCHR far *) thetext;
    UCHR tline[8];
    UINT i,j;
    int xx=x-8;
    if(mousepointeron) showhidecursor(0);
    if(fonttab[fntid][0] == 0)  // Font Version 0
        {
        pxhigh = fonttab[fntid][1];
        while(*text != 0)
            {
            if(*text == 10)
                x = xx, y += pxhigh;
            else
                {
                suchptr = fonttab[fntid] + 2;   // Begin seeking
                while((*suchptr != *text) && (*suchptr != 0))
                    suchptr += pxhigh + 1;
                if(*suchptr != 0)   // Found?
                    {   // Lets draw it
                    for(i=0;i<pxhigh;i++)
                        {
                        suchptr++;
                        tline[0] = *suchptr & 128;
                        tline[1] = *suchptr & 64;
                        tline[2] = *suchptr & 32;
                        tline[3] = *suchptr & 16;
                        tline[4] = *suchptr & 8;
                        tline[5] = *suchptr & 4;
                        tline[6] = *suchptr & 2;
                        tline[7] = *suchptr & 1;
                            // Decoded! Now draw it to x+j,y+i
                        for(j=0;j<8;j++)
                            if(tline[j])
                                if(fgc != -1)
//                                    setpixel((x+j),(y+i),fgc);
    _asm
        {
        sti
        mov cx, x
        add cx, j
        mov dx, y
        add dx, i
        mov bx, fgc
        mov ah, ci
        mov al, 3
        int 0FDh
        }
                                else
                                    { }
                            else
                                if(bgc != -1)
    _asm
        {
        sti
        mov cx, x
        add cx, j
        mov dx, y
        add dx, i
        mov bx, bgc
        mov ah, ci
        mov al, 3
        int 0FDh
        }
//                                    setpixel((x+j),(y+i),bgc);
                        }
                    }
                }
            text++;
            x += 8;
            }                
        }
    if(mousepointeron) showhidecursor(1);
    }

void drawsprite(UINT x, UINT y, char *sprite)
    {
    UINT xx=x;
    if(mousepointeron) showhidecursor(0);
    while(*sprite != 0)
        {
        if(*sprite == 0xA)
            x = xx, y++;
        else if(*sprite == 0xD)
            x = xx;
        else if(*sprite == 8)
            x--;
        else if(*sprite == ' ')
            x++;
        else
            {
            globvid = ((UCHR) *sprite);
            _asm
                {
                sti
                mov cx, x
                inc cx
                mov x, cx
                mov dx, y
                mov bx, globvid
                sub bx, 65
                mov ah, ci
                mov al, 3
                int 0FDh
                }
            }
        sprite++;
        }
    if(mousepointeron) showhidecursor(1);
    }

void getarea256(int x1, int y1, int x2, int y2, UCHR *buf)
    {
    int i,j;
    if(mousepointeron) showhidecursor(0);
    for(i=x1;i<=x2;i++)
        for(j=y1;j<=y2;j++)
            {
            _asm
                {
                mov cx, i
                mov dx, j
                mov ah, ci
                mov al, 4
                int 0FDh
                mov globvid, bx
                }
            *(buf++) = globvid;
            }
    if(mousepointeron) showhidecursor(1);
    }

void setarea256(int x1, int y1, int x2, int y2, UCHR *buf)
    {
    int i,j;
    if(mousepointeron) showhidecursor(0);
    for(i=x1;i<=x2;i++)
        for(j=y1;j<=y2;j++)
            {
            globvid = *(buf++);
            _asm
                {
                mov cx, i
                mov dx, j
                mov ah, ci
                mov al, 3
                mov bx, globvid
                int 0FDh
                }
            }
    if(mousepointeron) showhidecursor(1);
    }

